CodeForces 489E Hiking

题意:

数轴上有n(1000)个点  每个点有个距离源点的距离xi和美观值bi  主人公站在源点  他希望每步步长len  但每一步必须落在n个点其中一个上  且行进方向唯一  走到点n后可以计算旅行的价值

对于所有走过的点i  val = sum( sqrt( abs(x[i]-x[i-1]-len) ) / b[i] )  目标val尽量小  打印路径方案

思路:

第一次做分数规划题  这题是比较典型的01规划

简单描述一下01规划  就是 ans =
sum(ci*xi)/sum(di*xi) 其中xi为{0,1}

常规的解法是变形上述式子 F(ans) = sum(ci*xi) - sum(di*xi) * ans 这时我们将ans当成自变量  构造一个函数  容易发现F是单调的  那么就可以二分ans  将求解最值问题转换成判定可行性问题

对于本题  我们可以将val变形  val = sum(sqrt( abs(x[i]-x[i-1]-len)
)/sum(b[i])

那么也可以构建F函数 F(val) = sum(sqrt( abs(x[i]-x[i-1]-len) ) -
sum(b[i]) * val 这时我们发现这个表达式由于计算中存在i和i-1位置的联系所以不是那么简单  但是也可以发现  我们将原本的除法式子变成了减法式子  这就会出现承袭性!!  我们可以利用dp计算状态之间的转移 dp[i] = dp[j] +
sqrt( abs(x[i]-x[j]-len ) - b[i] * val (真谛就是用dp[j]包含了F中的sum)

这时二分val是logn的  对于每次的val我们可以用n^2的dp进行判定

代码:

#include<cstdio>
#include<iostream>
#include<cstring>
#include<string>
#include<algorithm>
#include<map>
#include<set>
#include<vector>
#include<queue>
#include<cstdlib>
#include<ctime>
#include<cmath>
#include<bitset>
using namespace std;
#define N 1010

int n, len;
int x[N], b[N];
int pre[N], out[N];
double dp[N];

bool yes(double ans) {
	for (int i = 1; i <= n; i++) {
		dp[i] = 1e30;
		for (int j = 0; j < i; j++) {
			double tmp = dp[j] + sqrt(1e-8 + abs(x[i] - x[j] - len))
					- ans * b[i];
			if (dp[i] > tmp) {
				dp[i] = tmp;
				pre[i] = j;
			}
		}
	}
	return dp[n] < 0;
}

int main() {
	scanf("%d%d", &n, &len);
	for (int i = 1; i <= n; i++)
		scanf("%d%d", &x[i], &b[i]);
	double l = 0, r = 1e10, mid;
	while (r - l > 1e-8) {
		mid = (l + r) / 2;
		if (yes(mid)) {
			r = mid;
		} else
			l = mid;
	}
	yes(l);
	len = 0;
	out[0] = n;
	while (pre[out[len]]) {
		out[len + 1] = pre[out[len]];
		len++;
	}
	for (int i = len; i >= 0; i--)
		printf("%d%s", out[i], (i == 0) ? "\n" : " ");
	return 0;
}
时间: 2024-10-25 00:39:16

CodeForces 489E Hiking的相关文章

CodeForces 489E Hiking (二分+DP)

题意: 一个人在起点0,有n个休息点,每个点有两个数值,分别表示距离起点的距离xi,以及所获得的愉悦值bi,这个人打算每天走L距离,但实际情况不允许他这么做.定义总体失望值val = sum(sqrt(Ri - L)) / sum(bi); 现在要使得val最小(这个人必须要到达最终的节点). 析:其实这个题并不难,看好这个式子,只要变形一下,sum(sqrt(Ri - L)) - val * sum(bi) = 0,要求val最小,假设val就是最后答案那肯定满足sum(sqrt(Ri - L

Codeforces Round #277.5 (Div. 2) JAVA版题解

Codeforces Round #277.5 (Div. 2) A. SwapSort time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output In this problem your goal is to sort an array consisting of n integers in at most n swaps. For t

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl